/* 
 * $Id: ftp_listener.h,v 1.6 2000/03/09 13:06:45 shane Exp $
 */

#ifndef FTP_LISTENER_H
#define FTP_LISTENER_H

#include <limits.h>
#include <pthread.h>

#define DEFAULT_FTP_PORT 21

typedef struct {
    int fd;
    int max_connections;
    int num_connections;
    int inactivity_timeout;
    pthread_mutex_t mutex;
    char dir[PATH_MAX+1];
    int listener_running;
    pthread_t listener_thread;
} ftp_listener_t;

int ftp_listener_init(ftp_listener_t *f, 
                      char *address, 
		      int port, 
		      int max_connections,
		      int inactivity_timeout);
int ftp_listener_start(ftp_listener_t *f);
void ftp_listener_wait(ftp_listener_t *f);

#endif /* FTP_LISTENER_H */

