/* 
 * $Id: watchdog.h,v 1.2 2000/03/09 13:10:51 shane Exp $
 */

#ifndef WATCHDOG_H
#define WATCHDOG_H

#include <pthread.h>

#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

typedef struct {
    pthread_t watched_thread;
    int watching_thread_active;
    pthread_t watching_thread;
    time_t inactivity;
    time_t alarm;
    pthread_mutex_t mutex;
} watchdog_t;

void watchdog_init(watchdog_t *w, pthread_t thread, time_t inactivity);
void watchdog_defer(watchdog_t *w);
void watchdog_destroy(watchdog_t *w);

#endif /* WATCHDOG_H */

